#pragma once

#define ASM_STUB_MAGIC_VALUE 0xdecbdecb

#ifdef __cplusplus
extern "C" {
#endif

	enum command {
		ASM_STUB_COMMAND_START = 0x0,
		ASM_STUB_COMMAND_STOP,
		ASM_STUB_COMMAND_COMMIT,
		ASM_STUB_COMMAND_ABORT,
	};

#ifdef _MSC_VER
	#include <windows.h>
	#ifdef _WIN64
		extern void inline send_asm_stub(DWORDLONG magic, DWORDLONG command, DWORDLONG arg);
	#else
		extern void inline send_asm_stub(DWORD magic, DWORD command, DWORD arg);
	#endif
#endif

	void host_start_record() {
#ifdef _MSC_VER
		send_asm_stub(ASM_STUB_MAGIC_VALUE, ASM_STUB_COMMAND_START, 1);
#else
		__asm__ __volatile__("int3\n" : : "a"(ASM_STUB_COMMAND_START), "b"(1), "c"(ASM_STUB_MAGIC_VALUE));
#endif
	}

	void host_stop_record() {
#ifdef _MSC_VER
		send_asm_stub(ASM_STUB_MAGIC_VALUE, ASM_STUB_COMMAND_STOP, 0);
#else
		__asm__ __volatile__("int3\n" : : "a"(ASM_STUB_COMMAND_STOP), "c"(ASM_STUB_MAGIC_VALUE));
#endif
	}

	void host_commit_record() {
#ifdef _MSC_VER
		send_asm_stub(ASM_STUB_MAGIC_VALUE, ASM_STUB_COMMAND_COMMIT, 1);
#else
		__asm__ __volatile__("int3\n" : : "a"(ASM_STUB_COMMAND_COMMIT), "b"(1), "c"(ASM_STUB_MAGIC_VALUE));
#endif
	}

	void host_abort(const char* reason) {
#ifdef _MSC_VER
		send_asm_stub(ASM_STUB_MAGIC_VALUE, ASM_STUB_COMMAND_ABORT, (UINT64)reason);
#else
		__asm__ __volatile__("int3\n" : : "a"(ASM_STUB_COMMAND_ABORT), "b"(reason), "c"(ASM_STUB_MAGIC_VALUE));
#endif
	}

#ifdef __cplusplus
}
#endif
